package com.jz.manage.moduls.controller.sys;

import com.jz.common.entity.sys.SysUser;
import com.jz.common.utils.Result;
import com.jz.common.utils.StatusCode;
import com.jz.manage.moduls.controller.BaseController;
import com.jz.manage.moduls.service.SysUserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

@RestController
@RequestMapping("/sys")
public class LoginController extends BaseController {

    @Autowired
    private SysUserService sysUserService;

    /**
     * 登录功能
     * @param account 账号
     * @param password 密码
     * @return
     */
    @GetMapping(value = "login")
    public Result<SysUser> login(String account, String password) {
        // 获取用户的信息
        SysUser sysUser = sysUserService.selectByUsername(account);
        if (sysUser == null) {
            return new Result<>(false, "用户不存在！", StatusCode.LOGINERROR);
        }
        if (sysUser.getAccount().equals(account) && sysUser.getPassword().equals(password)) {
            return new Result<>(true, "登录成功！", StatusCode.OK);
        }
        return new Result<>(false, "用户名或密码错误！", StatusCode.ERROR);
    }

    /*@ApiOperation("登录接口")
    @RequestMapping(value = "/login", method = RequestMethod.POST)
    public Result<JSONObject> login(@RequestBody SysUser sysUser, HttpServletRequest request) throws Exception {
        Result<JSONObject> result = new Result<>();
        String account = sysUser.getAccount();
        String password = sysUser.getPassword();

        Subject subject = SecurityUtils.getSubject();  //获取当前用户
        //将用户输入的用户名写密码封装到一个UsernamePasswordToken对象中
        UsernamePasswordToken token = new UsernamePasswordToken(account, password);
        //用Subject对象执行登录方法，没有抛出任何异常说明登录成功
        try {
            //执行登录方法，如果没有异常，就OK
            //login()方法会调用 Realm类中执行认证逻辑的方法，
            //并将这个参数传递给doGetAuthenticationInfo()方法
            subject.login(token);
            result.setSuccess(true);
            result.setCode(CommonConstant.SC_OK_200);
            result.setMessage("登录成功！");
            return result;
        } catch (UnknownAccountException e) {
            result.setSuccess(false);
            result.setCode(CommonConstant.SC_INTERNAL_SERVER_ERROR_500);
            result.setMessage("账号错误！");
            return result;
        } catch (IncorrectCredentialsException e) {
            result.setSuccess(false);
            result.setCode(CommonConstant.SC_INTERNAL_SERVER_ERROR_500);
            result.setMessage("密码错误！");
            return result;
        }
    }*/

}
